//+------------------------------------------------------------------+
//|                                                       ID3394.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot Up
#property indicator_label1  "Up"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  3
//--- plot Down
#property indicator_label2  "Down"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  3
//--- indicator buffers
double         UpBuffer[];
double         DownBuffer[];

input int NumCandles=1000;
input int IndentPoints=10;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Heiken(int buf,int shift)
  {
   return iCustom(NULL,0,"Heiken Ashi",buf,shift);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorDigits(_Digits);
//--- indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);
   SetIndexArrow(0,241);
   SetIndexArrow(1,242);
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int k=rates_total-prev_calculated-1;
   if(prev_calculated!=0)
      k++;
   k=MathMin(NumCandles,k);
   k=MathMax(k,1);
   for(int i=k;i>=0;i--)
     {
      int sign=Sign(i);
      if(sign==1)
        {

         if(LastArrow(i)!=1)
           {
            UpBuffer[i]=Low[i]-IndentPoints*Point;
           }
         else
           {
            UpBuffer[i]=0;
           }
         DownBuffer[i]=0;
        }
      else
        {
         UpBuffer[i]=0;
         if(sign==-1)
           {

            if(LastArrow(i)!=-1)
              {
               DownBuffer[i]=High[i]+IndentPoints*Point;
              }
            else
              {
               DownBuffer[i]=0;
              }
           }
         else
           {
            DownBuffer[i]=0;
           }
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
int Sign(int i)
  {
   double open=Heiken(2,i);
   double close=Heiken(3,i);
   if(close>open && Close[i]<Open[i])
      return 1;
   if(close<open && Close[i]>Open[i])
      return -1;
   return 0;
  }
//+------------------------------------------------------------------+
int LastArrow(int i)
  {
   int j=i+1;
   while(j<Bars)
     {
      if(UpBuffer[j]!=0)
         return 1;
      if(DownBuffer[j]!=0)
         return -1;
      j++;
     }
   return 0;
  }
//+------------------------------------------------------------------+
